package RRPC;

import java.util.Vector;

public class ClauseList {

    // A clause list is a set of _clauses
    // Use a vector

    private Vector _clauses;


    /////
    // CONSTRUCTORS

    public ClauseList (){
	_clauses = new Vector();
    }

    public ClauseList (Clause c){
	_clauses = new Vector();
	addClause(c);
    }

    public ClauseList (Literal l){
	_clauses = new Vector();
	addClause(new Clause(l));
    }

    public ClauseList (Vector __clauses){
	_clauses = (Vector) __clauses.clone();
    }

    public Vector _clauses (){
	return _clauses;
    }

    public void addClause (Clause p){
	_clauses.addElement(p);
    }

    public Clause clauseAt (int i){
	return (Clause) _clauses.elementAt(i);
    }

    public int size(){
	return _clauses.size();
    }

    // Don't side-effect this clause list
    public ClauseList concatenate (ClauseList c2){
	ClauseList c1 = new ClauseList(_clauses);
	for (int i = 0; i < c2.size(); i++){
	    c1.addClause(c2.clauseAt(i));
	}
	return c1;
    }

    // Do side-effect this clause list!!
    public void nconc (ClauseList c2){
	for (int i = 0; i < c2.size(); i++){
	    _clauses.addElement(c2.clauseAt(i));
	}
    }

    public String toString(){
	String result = "";
	for (int i = 0; i < _clauses.size(); i++){
	    result = result + _clauses.elementAt(i).toString() + "\n";
	}
	return result;
    }


}
