package RRPC;

import java.util.Vector;

public class ConstantTerm extends Term implements java.io.Serializable {
	static final long serialVersionUID = 5487598910442698364L;
    ////
    // VARIABLES
    private String name;

    /////
    // CONSTRUCTOR
    public ConstantTerm (String _name){
	name = "C" + _name;
    }

    /////
    // OTHER METHODS


    public Substitution unify(Term t, Substitution s) {
	if (equals(t)) {
	    return s;
	}
	// if the other is a variable, call Variable's unify()
	else if (t instanceof Variable)
	    return ((Variable)t).unify(this, s);
	else {
	    return null;
	}
    } 


    public Term removeQuantifiers (Vector quantifications){
	return this;
    }

    public Term substituteVariable(Variable oldVar, Term newVar){
	return this;
    }

    public Vector obtainVariables() {
	return new Vector();
    }


    public Term substitute(Substitution s) {
	return this;
    }

    public boolean equals(Object o) {
	if (o != null) {
	    if (o instanceof ConstantTerm) {
		return name.equals(((ConstantTerm)o).name);
	    }
	    else
		return false;
	}
	else
	    return false;
    } 

    //  The same as unification, but don't try in the other direction
    public Substitution subsumes (Term t, Substitution s){
	if (equals(t)) {
	    return s;
	} else {
	    return null;
	}
    }
	

    public String toString(){
	return name;
    }

    public void substituteTerm(Term newTerm, Term oldTerm){
    }

    // We already tried to match this one level up
    public Vector getPossibleMatches(Term t){
	return new Vector();
    }

    // Don't have to copy leaves
    public Term deepCopy(){
	return this;
    }

    public Term substituteTermAndCopy(Term newTerm, Term oldTerm){
	return this;
    }

} 
