package RRPC;

import java.util.Vector;

public final class FalseProposition extends Proposition 
    implements java.io.Serializable{
	static final long serialVersionUID = -5217311032037167128L;
    public String toString(){
	return "F";
    }

    /**
     * from Sentence abstract class
     */
    public Sentence substitute(Substitution s) {
	return this;
    }

    public Sentence substituteVariable(Variable oldVar, Term newVar){
	return this;
    }

    public Sentence removeQuantifiers (Vector quantifications){
	return this;
    }

    //  Should really return true if p is also the false prop
    public Substitution unify(Proposition p, Substitution s) {
	return null;
    } 

    //  False subsumes everything
    public boolean subsumes (Proposition p, Substitution s) {
	return true;
    }

    public Vector obtainVariables() {
	return new Vector();
    } 

    // Nothing to substitute
    public void substituteTerm(Term newTerm, Term oldTerm){
    }

    // Return a vector of terms contained in this proposition that unify with t
    public Vector getPossibleMatches(Term t){
	return new Vector();
    }

    // We don't really need to copy the leaves
    public Proposition deepCopy(){
	return this;
    }

    public Proposition substituteTermAndCopy(Term newTerm, Term oldTerm){
	return this;
    }


} 
