package RRPC;

import java.util.Vector;

public abstract class Literal 
    implements java.io.Serializable {
	static final long serialVersionUID = -3518859178523315183L;
	protected Proposition _proposition;

	public Proposition proposition(){
		return _proposition;
	}

	public abstract boolean isPositive();
	public abstract boolean isNegative();

    public Substitution unify(Literal l){
	return unify(l, new Substitution());
    }

    // Assume substitution s is already given to us
    public abstract Substitution unify (Literal l, Substitution s);

    public abstract boolean subsumes (Literal l);

    // Substitute newTerm in for oldTerm wherever it occurs
    // term1 might be compound or a constant (not necessarily a var)
    // Okay to check for object equality with oldTerm
    public void substituteTerm(Term newTerm, Term oldTerm){
	_proposition.substituteTerm(newTerm, oldTerm);
    }

    // Return a vector of terms contained in this literal that unify with t
    public Vector getPossibleMatches(Term t){
	return _proposition.getPossibleMatches(t);
    }

    public abstract Literal deepCopy();

    public abstract Literal substituteTermAndCopy(Term newTerm, Term oldTerm);


} // end of CLASS Literal
