package RRPC;

import java.util.Vector;

public class Negation extends Sentence {

	private Sentence _s;

	public Negation (Sentence s){
		_s = s;
	}

	public Sentence eliminateEquivalences(){
		return new Negation (_s.eliminateEquivalences());
	}

	public Sentence eliminateImplications(){
		return new Negation (_s.eliminateImplications());
	}

	// Return a sentence that's equivalent to this one
	public Sentence driveInNegations(){
		return _s.negate();
	}

	// Return a sentence that's the negative of this one.
	public Sentence negate(){
		return _s.driveInNegations();
	}

	public Sentence substituteVariable(Variable oldVar, Term newVar){
		return new Negation (_s.substituteVariable(oldVar, newVar));
	}

  public Sentence substitute(Substitution s) {
    return new Negation(_s.substitute(s));
  }

	public Sentence renameVariables(){
		return new Negation (_s.renameVariables());
	}

	public void extractQuantifications (Vector quantifications){
          _s.extractQuantifications(quantifications);
	}

	public Sentence removeQuantifiers (Vector quantifications){
		return new Negation(_s.removeQuantifiers(quantifications));
	}

	// If this s is not a proposition, we haven't done the previous
	// steps properly
	public ClauseList makeClauses(){
		return new ClauseList(new NegativeLiteral((Proposition) _s));
	}

	public String toString(){
		return "~" + _s;
	}


}