package RRPC;

public class NegativeLiteral extends Literal 
    implements java.io.Serializable {
	static final long serialVersionUID = 6099891078877343370L;
	public NegativeLiteral (Proposition p){
		_proposition = p;
	}

	public boolean isPositive(){
		return false;
	}

	public boolean isNegative(){
		return true;
	}

    // Assume substitution s is already given to us
    public Substitution unify (Literal l, Substitution s){
	if (l.isNegative()){
	    return _proposition.unify(l.proposition(),s);
	} else {
	    return null;
	}
    }

    public boolean subsumes (Literal l) {
	return ((l.isPositive() && 
		 (l.proposition() instanceof TrueProposition)) ||
		(l.isNegative() &&
		_proposition.subsumes(l.proposition())));
    }

    public Literal deepCopy() {
	return new NegativeLiteral(_proposition.deepCopy());
    }

    public Literal substituteTermAndCopy(Term newTerm, Term oldTerm){
	return new NegativeLiteral
	    (_proposition.substituteTermAndCopy(newTerm, oldTerm));
    }


	public String toString(){
		return "~" + proposition().toString();
	}

}
