package RRPC;

public class PositiveLiteral extends Literal 
    implements java.io.Serializable {
	static final long serialVersionUID = 1377358479990385405L;

	public PositiveLiteral (Proposition p){
		_proposition = p;
	}

	public boolean isPositive(){
		return true;
	}

	public boolean isNegative(){
		return false;
	}

	public String toString(){
		return proposition().toString();
	}

    // Assume substitution s is already given to us
    public Substitution unify (Literal l, Substitution s){
	if (l.isPositive()){
	    return _proposition.unify(l.proposition(),s);
	} else {
	    return null;
	}
    }

    public boolean subsumes (Literal l) {
	return (l.isPositive() &&
		 _proposition.subsumes(l.proposition()));
    }

    public Literal deepCopy() {
	return new PositiveLiteral(_proposition.deepCopy());
    }

    public Literal substituteTermAndCopy(Term newTerm, Term oldTerm){
	return new PositiveLiteral
	    (_proposition.substituteTermAndCopy(newTerm, oldTerm));
    }

}
