package RRPC;

import java.util.Vector;

abstract public class Term implements java.io.Serializable {
	static final long serialVersionUID = -9034593071285636183L;
    abstract public Term substituteVariable (Variable oldVar, Term newVar);

    // Convert free vars to constants
    abstract public Term removeQuantifiers (Vector quantifications);

    /**
     * Given two terms, return their most general unifier, or null if they don't
     * unify.  <s> may be mutated.
     */
    abstract public Substitution unify(Term t, Substitution s);

    /**
     * returns a Vector of Terms that are Variables.  If this Term isn't a Variable,
     * an empty Vector is returned.
     */
    abstract public Vector obtainVariables();

    abstract public Term substitute (Substitution s);

    abstract public Substitution subsumes (Term t, Substitution s);

    public abstract void substituteTerm(Term newTerm, Term oldTerm);

    // Return a vector of terms contained in this proposition that unify with t
    public abstract Vector getPossibleMatches(Term t);

    public abstract Term deepCopy();

    public abstract Term substituteTermAndCopy(Term newTerm, Term oldTerm);

} 
