package RRPC;

import java.util.Vector;

public final class TrueProposition extends Proposition 
    implements java.io.Serializable {

	static final long serialVersionUID = 2205772316433261810L;
    public Sentence substitute(Substitution s) {
	return this;
    }

    public Sentence substituteVariable (Variable oldVar, Term newVar){
	return this;
    }

    public Sentence removeQuantifiers (Vector quantifications){
	return this;
    }

    public String toString(){
	return "T";
    }

    // Nothing unifies with True;  return null
    public Substitution unify (Proposition p, Substitution s) {
	return null;
    } 

    // True subsumes nothing
    public boolean subsumes (Proposition p, Substitution s){
	return false;
    }

    /**
     * from Proposition abstract class.
     *
     * No variables are in an TrueProposition.  Therefore, return empty Vector.
     */
    public Vector obtainVariables() {
	return new Vector();
    } 

    // Nothing to substitute
    public void substituteTerm(Term newTerm, Term oldTerm){
	
    }

    // Return a vector of terms contained in this proposition that unify with t
    public Vector getPossibleMatches(Term t){
	return new Vector();
    }

    // We don't really need to copy the leaves
    public Proposition deepCopy(){
	return this;
    }

    public Proposition substituteTermAndCopy(Term newTerm, Term oldTerm){
	return this;
    }


} 
